<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Task 43.70</title>
</head>

<body>
    <div class="container mt-4">
        <h2 class="text-center">Voucher History</h2>
        <div class="row jumbotron p-3 m-0">
            <div class="col-md-12">
                <form>
                    <div class="form-row">
                        <h2>Thông tin người chơi</h2>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-4">
                            <label>Username</label>
                            <input type="text" id="user-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>First Name</label>
                            <input type="text" id="first-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>Last name</label>
                            <input type="text" id="last-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
            <table id="table-voucher-history" class="table table-bordered table-striped table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th scope="col">STT</th>
                        <th scope="col">Mã Voucher</th>
                        <th scope="col">Phần trăm giảm giá</th>
                        <th scope="col">Ngày tạo</th>
                    </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
    var gPlayerInfoObj = {};
    var gVoucherHistoryData = [];

    var gNameCol = ["stt", "voucherCode", "discountPercentage", "dateCreated"];
    const gSTT_COL = 0;
    const gVOUCHER_CODE_COL = 1;
    const gDISCOUNT_PERCENTAGE_COL = 2;
    const gDATE_CREATED_COL = 3;

    var gPlayerDataTable = $("#table-voucher-history").DataTable({
        columns: [
            { data: gNameCol[gSTT_COL] },
            { data: gNameCol[gVOUCHER_CODE_COL] },
            { data: gNameCol[gDISCOUNT_PERCENTAGE_COL] },
            { data: gNameCol[gDATE_CREATED_COL] },
        ],
        columnDefs: [//đinhj nghĩa các cột cần hiện ra
            {
                targets: gSTT_COL,
                className: "text-center text-primary",
                render: function (data, type, row, meta) {
                    return meta.row + meta.settings._iDisplayStart + 1;
                }
            },
            {
                targets: gVOUCHER_CODE_COL,
                className: "text-center text-success",
            },
        ]
    });

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vCurrentUrl = window.location.href;
        catchDataFromUrl(vCurrentUrl);
        loadPlayerInfoToForm(gPlayerInfoObj);
        getPlayerVoucherHistory(gPlayerInfoObj.userName);
    }

    
    //hàm xử lý thực hiện lấy queryString từ Url trang web
    function catchDataFromUrl(paramCurrentURL) {
        "use strict";
        var vNewUrl = new URL(paramCurrentURL);
        // get parameters
        var vUname = vNewUrl.searchParams.get("user_name");
        var vFname = vNewUrl.searchParams.get("first_name");
        var vLname = vNewUrl.searchParams.get("last_name");
        // Save to var global
        gPlayerInfoObj.userName = vUname;
        gPlayerInfoObj.firstName = vFname;
        gPlayerInfoObj.lastName = vLname;
        // show result in console.log
        console.log("gOrderParamsObj = " + JSON.stringify(gPlayerInfoObj, true, 2));
    }

    function loadPlayerInfoToForm(paramDataObj) {
        $("#user-name").val(paramDataObj.userName);
        $("#first-name").val(paramDataObj.firstName);
        $("#last-name").val(paramDataObj.lastName);
    }

    //Sau đó, gọi api để lấy ra được danh sách lịch sử tung xúc xắc, console ra responseText (Tách thành 04 bước)
    function getPlayerDiceHistory(paramUserName) {
        console.log(paramUserName);
        $.ajax({
            url: gBASE_URL + "/voucher-history?username=" + paramUserName,
            async: false,
            type: "GET",
            dataType: "json",
            success: function(responseObject) {
                console.log("responseText >>> " + JSON.stringify(responseObject));
                if (responseObject.dices.length > 0) {
                    var vCount = 0;
                    while (vCount < responseObject.dices.length) {
                        var bDice = {"game": vCount, "dice": responseObject.dices[vCount] };
                        gVoucherHistoryData.push(bDice);
                        vCount++;
                    }
                    loadDataToVoucherTable(gVoucherHistoryData);
                }
            },
            error: function(xhr, status, error) {
                console.log(error);
            },
        });
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function  loadDataToVoucherTable(paramVoucherArr) {
        console.log(paramVoucherArr);
        gPlayerDataTable.clear();
        gPlayerDataTable.rows.add(paramVoucherArr);
        gPlayerDataTable.draw();
    }
</script>
</html>